Global Const pi = 3.141592654

Global main_array()
Global temp_array()
Global pen_type As Integer
Global file_pro As String
Global picture_y As Integer
Global picture_x As Integer

Function arcsin (x)

If x >= 1 Then
temp = pi / 2
Else
temp = Atn(x / Sqr(-x * x + 1))
End If
arcsin = temp

End Function

Sub copy_array ()

ReDim temp_array(-5 To picture_y + 5)
For y = -5 To picture_y + 5
    temp_array(y) = main_array(y)
Next y

End Sub

Sub down ()

copy_array

For y = -5 + 8 To picture_y + 5
    main_array(y) = temp_array(y - 8)
Next y
For y = -5 To -5 + 8
    main_array(y) = temp_array(y - 8 + picture_y)
Next y

End Sub

Sub draw (button, y)

If button = 1 Or button = 2 Then    'only work for left and right button

If y > picture_y Then y = picture_y 'this stops it crashing
If y < 0 Then y = 0                 'so does this
Select Case pen_type                'do all the pen types
Case 0                              'thick line pen type
    If button = 1 Then
    main_array(y) = main_array(y) - 30
    main_array(y + 1) = main_array(y + 1) - 30
    Else
    main_array(y) = main_array(y) + 30
    main_array(y + 1) = main_array(y + 1) + 30
    End If
Case 1                              'airbrush pen type
    If button = 1 Then              'left mouse button
	main_array(y - 3) = main_array(y - 3) - 1
	main_array(y - 2) = main_array(y - 2) - 4
	main_array(y - 1) = main_array(y - 1) - 8
	main_array(y - 0) = main_array(y - 0) - 10
	main_array(y + 1) = main_array(y + 1) - 8
	main_array(y + 2) = main_array(y + 2) - 4
	main_array(y + 3) = main_array(y + 3) - 1
    End If
    If button = 2 Then              'right mouse button
	main_array(y - 3) = main_array(y - 3) + 1
	main_array(y - 2) = main_array(y - 2) + 4
	main_array(y - 1) = main_array(y - 1) + 8
	main_array(y - 0) = main_array(y - 0) + 10
	main_array(y + 1) = main_array(y + 1) + 8
	main_array(y + 2) = main_array(y + 2) + 4
	main_array(y + 3) = main_array(y + 3) + 1
    End If
Case 2                              'fine line pen type
    If button = 1 Then main_array(y) = main_array(y) - 10
    If button = 2 Then main_array(y) = main_array(y) + 10
Case 3                              'smoothing pen type
    main_array(y) = (main_array(y + 1) + main_array(y) + main_array(y - 1)) / 3
Case 4                              'sharpen pen type
    If main_array(y) < 128 Then main_array(y) = main_array(y) - 10
    If main_array(y) >= 128 Then main_array(y) = main_array(y) + 10
End Select
For i = -3 To 3                     'limit values and redraw
If main_array(y + i) > 255 Then main_array(y + i) = 255
    If main_array(y + i) < 0 Then main_array(y + i) = 0
    form1.Picture1.Line (-1, y + i)-(picture_x, y + i), RGB(main_array(y + i), main_array(y + i), main_array(y + i)), BF
Next i
End If                              'end left and right mouse type

End Sub

Sub enlarge ()

copy_array

picture_y = Int(picture_y * 1.2)        'calculate new array size
ReDim main_array(-5 To picture_y + 5)
For y = -5 To picture_y + 4             'copy back
    main_array(y) = temp_array(Int(y / 1.2) + 1)
Next y

End Sub

Sub flip ()

copy_array

For y = -5 To picture_y + 5
    main_array(y) = temp_array(picture_y - y)
Next y

End Sub

Sub neaten ()

'neat and tidy sub
For i = 1 To 5                  'do it 5 times
For y = 0 To picture_y          'do picture from top to bottom
    If square(main_array(y - 1) - main_array(y + 1)) < 10000 Then
	main_array(y) = (main_array(y - 1) + main_array(y) + main_array(y + 1)) / 3
    Else
	If main_array(y) < 128 Then main_array(y) = main_array(y) - 10
	If main_array(y) > 127 Then main_array(y) = main_array(y) + 10
    End If
    If main_array(y) > 255 Then main_array(y) = 255
    If main_array(y) < 0 Then main_array(y) = 0
Next y
Next i

End Sub

Sub negative ()

For y = -5 To picture_y + 5
    main_array(y) = 255 - main_array(y)
Next y

End Sub

Sub open_pro_sub ()

Open file_pro$ For Input As #1
pro_size_given = False      'earlier file type compatability
Do
Input #1, a$
If a$ = "[EOF]" Then Exit Do
If a$ = "[Mesh size]" Then
    Input #1, picture_y
    pro_size_given = True
    reset_array
End If
If a$ = "[Mesh Data]" Then
    If pro_size_given = False Then
    picture_y = 128
    reset_array
    End If
    For y = -5 To picture_y + 5
	Input #1, main_array(y)
    Next y
End If
Loop
Close #1

End Sub

Sub redraw_all ()

Dim old_x, old_y, spacing, angle, distance

If form1.WindowState <> 1 Then
If form1.Height < 4000 Then form1.Height = 4000
If form1.Width < 8000 Then form1.Width = 8000

form1.Frame1.Top = form1.Height - form1.Frame1.Height - 500

form1.Picture1.ScaleHeight = picture_y + 1      'set drawbox height
form1.Picture1.Height = (picture_y + 1) * 15
form1.Picture1.ScaleWidth = picture_x

form1.Picture2.Width = form1.Width - 3700
form1.Picture2.Height = form1.Height - 1000
form1.Picture2.Cls                              'gobbledy gook
form1.Caption = "Profiles and Mouldings, 1996 Bruno Postle <bruno@postle.net> " + file_pro$
If picture_y > Val(form1.Frame1.Top - 900) / 15 Then
form1.Edit_Button(4).Enabled = False
Else
form1.Edit_Button(4).Enabled = True
End If
For y = -5 To picture_y + 5                 'redraw picture1 [painting area]
form1.Picture1.Line (-1, y)-(picture_x, y), RGB(main_array(y), main_array(y), main_array(y)), BF
Next y

old_x = 0: old_y = 0                        'redraw picture2 [profile area]
spacing = form1.Picture2.ScaleHeight / picture_y / 1.5
For y = 0 To picture_y
    angle = arcsin(main_array(y) / 255)
    distance = spacing / Cos(angle - (pi / 4))
    new_x = old_x + (distance * Cos(angle))
    new_y = old_y + (distance * Sin(angle))
    form1.Picture2.Line (5 + old_x, 5 + old_y)-(5 + new_x, 5 + new_y), RGB(0, 0, 0)
    old_x = new_x
    old_y = new_y
Next y
 
End If

End Sub

Sub reduce ()

copy_array

picture_y = Int(picture_y * .75)        'calculate new array size
ReDim main_array(-5 To picture_y + 5)
For y = -4 To picture_y + 3             'copy back
    main_array(y) = temp_array(Int(y / .75) + 1)
Next y

End Sub

Sub reset_array ()

ReDim main_array(-5 To picture_y + 5)

For y = -5 To picture_y + 5
    main_array(y) = 255
Next y

End Sub

Sub save_pro_sub ()

Open file_pro$ For Output As #1

Print #1, "[Header]"
Print #1, "Software by Bruno Postle"
Print #1, "mailto:bruno@postle.net"
Print #1, "Note for anyone wanting to play"
Print #1, "around with these files:"
Print #1, "The first five and the last five"
Print #1, "numbers in the list are buffers,"
Print #1, "they are not displayed or used"
Print #1, "for calculating profiles."
Print #1, "ie/ the total no. of [Mesh Data]"
Print #1, "values is [Mesh size] + 1 + 10"
Print #1, "All data values are between 0"
Print #1, "and 255."
Print #1, "[Date]"
Print #1, Format$(Now, "dd-mm-yyyy")
Print #1, "[Mesh size]"
Print #1, Trim$(Str$(picture_y))
Print #1, "[Mesh Data]"
For y = -5 To picture_y + 5
Print #1, Trim$(Str$(Int(main_array(y))))
Next y
Print #1, "[EOF]"
Close #1

End Sub

Function square (a)

square = a * a

End Function

Sub up ()

copy_array

For y = -5 To picture_y + (5 - 8)
    main_array(y) = temp_array(y + 8)
Next y
For y = picture_y + (5 - 8) To picture_y + 5
    main_array(y) = temp_array(y + 8 - picture_y)
Next y

End Sub

